<template>
  <form class="edit-project" @submit.prevent="submit">
    <div class="form-field">
      <label for="email">Почта</label>
      <prime-input-text
        id="email"
        v-model="email"
        type="text"
        :disabled="isLoading"
      />
    </div>

    <div v-if="isEditingHimself === false" class="form-field">
      <label for="role">Роль</label>
      <prime-dropdown
        id="role"
        v-model="role"
        :options="roles"
        :disabled="isLoading"
      />
    </div>

    <prime-button label="Сохранить" type="submit" />
  </form>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeDropdown from 'primevue/dropdown/Dropdown.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent, PropType } from 'vue';
// import { UpdateUser } from '@/api/handler/user';
import { updateUser, updateUserByHimselfUser } from '@/api/handler/user';
import { User, parseRole, Role, parseToNumbers } from '@/models/user';


type Data = Omit<User, 'id' | 'role'> & {
  role: 'Админ' | 'Пользователь';
  isLoading: boolean;
}

export default defineComponent({
  name: 'edit-user',
  components: {
    PrimeButton,
    PrimeDropdown,
    PrimeInputText,
  },
  props: {
    user: { type: Object as PropType<User>, required: true },
    isEditingHimself: { type: Boolean, default: false },
  },
  emits: ['close', 'update'],
  data(): Data {
    return {
      email: '',
      role: 'Пользователь',

      isLoading: false,
    };
  },
  computed: {
    roles(): ('Админ' | 'Пользователь')[] {
      return ['Админ', 'Пользователь'];
    },
  },
  created() {
    if (!this.user) {
      return;
    }

    const { email, role } = this.user;
    this.email = email;
    this.role = this.formatRole(role);
  },
  methods: {
    formatRole(role: Role) {
      return parseRole(role);
    },
    async submit() {
      this.isLoading = true;
      const { id } = this.user;
      const { email, role } = this;
      let promise;
      if (this.isEditingHimself) {
        promise = updateUserByHimselfUser({
          email,
        });
      } else {
        promise = updateUser({ email, role: parseToNumbers(role), id });
      }

      const res = await promise;
      if (res.__state === 'success') {
        this.$emit('update', res.data);
        this.$emit('close');
      } else {
        this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
      }
      this.isLoading = false;
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}
</style>
